%% definice obrazku a cesty k nim
clear all; close all; clc
images = {'1_1.tif' '1_2.tif' '2_2.tif' '2_7.tif' '3_1.tif' '3_5.tif' '10_1.tif'... % 1 - 7
'10_2.tif' '12_1.tif' '12_2.tif' '15_3.tif' '15_6.tif' '25_2.tif' '25_5.tif'... % 8 - 14
'33_2.tif' '33_6.tif' '40_2.tif' '40_5.tif'}; % 15 - 18
imdir = 'images';

% nacteni obrazku
% obr1 = 1;
% obr2 = 2;
% im1 = imread([imdir '/' images{obr1}]);
% im2 = imread([imdir '/' images{obr2}]);

% imS = computeAuxVals(images, imdir, segWinSize, orientationWinSize);
% save images/imS imS;


load images/imS;
addpath ./kody_cv1


%%
o1 = 1; o2 = 2;% ms = zeros(length(imS));

[~, mAi2Align im2SkAlign] = ...
    align2(imS(o1).imageSkeleton, imS(o1).singularityPoints, imS(o2).imageSkeleton, imS(o2).minutiaArray, imS(o2).singularityPoints);

%%% FUNKCE, KTERE BUDOU TVORIT STUDENTI - ukol na vytvoreni %%%
[matchingScore, nbmatch, inputmatch, dbmatch] = match(imS(o1).minutiaArray, mAi2Align);
%%%                      %%%                         %%%

mtchim = showsimilarity(imcomplement(full(imS(o1).imageSkeleton)), imcomplement(full(im2SkAlign)));
figure; imshow(mtchim); hold on
[x1,y1]= find(dbmatch == 1); [x2,y2]= find(dbmatch == 2);
[x3,y3]= find(inputmatch == 1); [x4,y4]= find(inputmatch == 2);
plot(y1,x1,'ob','markersize',8); plot(y2,x2,'sb','markersize',8);
plot(y3,x3,'or','markersize',8); plot(y4,x4,'sr','markersize',8);
title([imS(o1).name ' (' num2str(o1) ') x ' imS(o2).name ' (' num2str(o2)...
  '), score = ' num2str(matchingScore)], 'interpreter', 'none')

%% fingercode
%%% ZDE BUDE ZA UKOL VYVORIT VSECHNO, PROTOZE TO JE JEDNODUCHE
Gfilt = GaborFilter_creation;
o1 = 1; o2 = 2; score = zeros(length(imS), length(imS)-1);
[fingercode1 Fm1] = fingercode_creation(imS(o1).im, Gfilt, getCore(imS(o1).singularityPoints));

for o2 = 2 : 2
    [mRi2Align mAi2Align im2SkAlign offset angle core] = ...
        align2(imS(o1).imageSkeleton, imS(o1).singularityPoints, imS(o2).imageSkeleton, imS(o2).minutiaArray, imS(o2).singularityPoints);
    im2Align = imrotatearound(imshift(imS(o2).im, offset), angle, core);
    [fingercode2 Fm2] = fingercode_creation(im2Align, Gfilt, getCore(imS(o1).singularityPoints));
    
    D = abs(fingercode1 - fingercode2);
    matchongScoreG = mean(D);
    mch(o2 - 1) = matchongScoreG;
    
    if o2 == 2
        mtchim = showsimilarity(imcomplement(full(imS(o1).imageSkeleton)), imcomplement(full(im2SkAlign)));
    end
end

figure; plot(mch); xlabel('cislo obrazku'); ylabel('matching score'); title('fingercode matching')
figure; imshow(mtchim);

% ukazka fingercodu
figure; 
for m = 1 : size(Fm1, 1), 
    subplot(2,4,m); imshow(squeeze(Fm1(m, :, :)) / max(max(squeeze(Fm1(m, :, :))))); 
end
title('fingercode 1')
figure; 
for m = 1 : size(Fm2, 1),
    subplot(2,4,m); imshow(squeeze(Fm2(m, :, :)) / max(max(squeeze(Fm2(m, :, :))))); 
end
title('fingercode 2')